<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_1</title>
</head>
<body>
    <h1>Capitulo 1</h1>
    <a>Ejercicio 5</a>

    <script>
    //Copiado
    const oneEditAway = (cadena1 = "", cadena2 = "") => {
        if (!cadena1) return console.warn("No ingreso la palabra 1");
        if (!cadena2) return console.warn("No ingreso la palabra 2");

        if ( cadena1.length === cadena2.length ) {
            return oneEditReplace(cadena1, cadena2);
        } else if (cadena1.length + 1 === cadena2.length) {
            return oneEditInsert(cadena2, cadena1);
        } else if (cadena1.length - 1 === cadena2.length) {
            return oneEditInsert(cadena2, cadena1);
        }
        return false;
      
    }

    const oneEditReplace = (cadena1 , cadena2) => { 
        let foundDifference = false;
        for (var i = 0; i < cadena1.length; i++) {
            if (cadena1.charAt(i) != cadena2.charAt(i)) {
                if (foundDifference) {
                    return false;
                }
                foundDifference = true;
            }
        }
        return true
    }

    const oneEditInsert = (cadena1, cadena2) => {

        let index1 = 0,
            index2 = 0;

        while (index2 < cadena2.length && index1 < cadena1.length) {
            if (cadena1.charAt(index1) != cadena2.charAt(index2)) {
                if (index1 != index2) {
                    return false
                }
                index2++;
            } else {
                index1++;
                index2++;
            }
        }
        return true;        
    }

    
    let one = oneEditAway("pale", "ple");
    console.log(one)


    </script>
    
</body>
</html>